# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# perl_vendorlib/perl_vendorarch not defined by default prior to F-2
%{!?perl_vendorlib: %global perl_vendorlib %(eval "`perl -V:installvendorlib`"; echo $installvendorlib)}

# We don't really need ExtUtils::MakeMaker ≥ 6.30
%global old_eumm %(perl -MExtUtils::MakeMaker -e 'print (($ExtUtils::MakeMaker::VERSION < 6.30) ? 1 : 0);' 2>/dev/null || echo 0)

# We need to patch the test suite if we have an old version of Test::More
%global old_test_more %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.88) ? 1 : 0);' 2>/dev/null || echo 0)

Name:		perl-Sub-Uplevel
Epoch:		1
Version:	0.24
Release:	1.%{__distinit}%{__distvers}
Summary:	Run a perl function in an upper stack frame
Group:		Development/Libraries
License:	GPL+ or Artistic
URL:		http://search.cpan.org/dist/Sub-Uplevel/
Source0:	http://search.cpan.org/CPAN/authors/id/D/DA/DAGOLDEN/Sub-Uplevel-%{version}.tar.gz
Patch0:		Sub-Uplevel-0.24-old-eu::mm.patch
Patch1:		Sub-Uplevel-0.24-old-Test::More.patch
Patch2:		Sub-Uplevel-0.24-no-Test::Requires.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
%if %(perl -e 'print $] >= 5.008001 ? 1 : 0;')
BuildRequires:	aspell-en
%else
BuildRequires:	aspell-en-gb
%endif
BuildRequires:	perl(constant)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(Test::More) >= 0.47
BuildRequires:	perl(Pod::Coverage::TrustPod)
BuildRequires:	perl(Pod::Wordlist::hanekomu)
BuildRequires:	perl(Test::CPAN::Meta)
BuildRequires:	perl(Test::Pod)
BuildRequires:	perl(Test::Pod::Coverage)
BuildRequires:	perl(Test::Portability::Files)
BuildRequires:	perl(Test::Spelling) >= 0.12
# Test::Version -> Test::Exception -> Sub::Uplevel
%if 0%{!?perl_bootstrap:1}
BuildRequires:	perl(Test::Version)
%endif
# No Perl::Critic or Test::Requires prior to Perl 5.8.8 (FC-5)
# Test::Requires -> Test::Perl::Critic -> Perl::Critic -> Exception::Class -> Test::Kwalitee ->
#   Module::CPANTS::Analyse -> Test::Warn -> Sub::Uplevel
%if %(perl -e 'print $] >= 5.008008 ? 1 : 0;') && 0%{!?perl_bootstrap:1}
BuildRequires:	perl(Perl::Critic::Policy::Lax::ProhibitStringyEval::ExceptForRequire)
BuildRequires:	perl(Test::Perl::Critic)
BuildRequires:	perl(Test::Requires)
%endif
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

# Remove bogus perl(DB) provide (rpm 4.9 onwards)
%global __provides_exclude ^perl\\(DB\\)$

%description
Like Tcl's uplevel() function, but not quite so dangerous.  The
idea is just to fool caller().  All the really naughty bits of
Tcl's uplevel() are avoided.

%prep
%setup -q -n Sub-Uplevel-%{version}

# We don't really need ExtUtils::MakeMaker ≥ 6.30
%if %{old_eumm}
%patch0 -p1
%endif

# We need to patch the test suite if we have an old version of Test::More
%if %{old_test_more}
%patch1 -p1
%endif

# Work around absence of Test::Requires if necessary
%if %(perl -e 'print $] >= 5.008008 ? 0 : 1;')
%patch2 -p1
%endif

# Kludge to remove bogus perl(DB) provide (prior to rpm 4.9)
%global provfilt /bin/sh -c "%{__perl_provides} | grep -Fvx 'perl(DB)'"
%define __perl_provides %{provfilt}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install PERL_INSTALL_ROOT=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
find %{buildroot} -depth -type d -exec rmdir {} ';' 2>/dev/null
%{_fixperms} %{buildroot}

%check
make test
make test TEST_FILES="$(echo $(find xt/ -name '*.t'))"

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes LICENSE README README.PATCHING
%{perl_vendorlib}/Sub/
%{_mandir}/man3/Sub::Uplevel.3pm*

%changelog
* Tue Feb 21 2012 Paul Howarth <paul@city-fan.org> 1:0.24-1
- Update to 0.24
  - Added: the $Sub::Uplevel::CHECK_FRAMES global constant to enable the frame
    depth checking and compile it out if not needed
  - Fixed: Perl 5.15 series Carp changes output format of messages (adds a
    period); this fixes the test regular expressions
- BR: perl(constant)
- Package README and README.PATCHING
- Explicitly run release tests
- Add patches to support building with Test::More < 0.88,
  ExtUtils::MakeMaker < 6.30 and no Test::Requires on older distributions
- Add buildreqs for author/release tests:
  - perl(Perl::Critic::Policy::Lax::ProhibitStringyEval::ExceptForRequire)
  - perl(Pod::Coverage::TrustPod)
  - perl(Pod::Wordlist::hanekomu)
  - perl(Test::CPAN::Meta)
  - perl(Test::Perl::Critic)
  - perl(Test::Portability::Files)
  - perl(Test::Requires)
  - perl(Test::Spelling) ≥ 0.12 and aspell-en/aspell-en-gb
  - perl(Test::Version)

* Wed Jun 29 2011 Paul Howarth <paul@city-fan.org> 1:0.22-5
- Rebuild for perl 5.14.1 in Rawhide
- Tweak provides filter to work with rpm 4.9 onwards
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Wed Jun 23 2010 Paul Howarth <paul@city-fan.org> 1:0.22-3
- Rebuild for perl 5.12.1 in Rawhide

* Mon May 31 2010 Paul Howarth <paul@city-fan.org> 1:0.22-2
- Fix dist tag for RHEL-6 Beta

* Sat Feb 13 2010 Paul Howarth <paul@city-fan.org> 1:0.22-1
- Epoch bump as per Fedora package

* Thu Feb 11 2010 Paul Howarth <paul@city-fan.org> 0.22-2
- Drop bogus provide of perl(DB)
- Use %%{_fixperms} macro rather than our own %%{__chmod} incantation

* Wed Nov 18 2009 Paul Howarth <paul@city-fan.org> 0.22-1
- Update to 0.22 (added ":aggressive" tag to force reloading of Exporter)
- Dist tag for rawhide no longer needs special-casing

* Sat Sep 26 2009 Paul Howarth <paul@city-fan.org> 0.20.02-2
- Define RPM macros in global scope

* Fri Sep 12 2008 Paul Howarth <paul@city-fan.org> 0.20.02-1
- Update to 0.2002

* Wed Sep 10 2008 Paul Howarth <paul@city-fan.org> 0.20.01-1
- Update to 0.2001
- Add buildreq perl(ExtUtils::MakeMaker)
- Tweak dist tag macros to work on current Rawhide with three-part releasenum

* Fri Feb 15 2008 Paul Howarth <paul@city-fan.org> 0.19.01-1
- Update to 0.1901
- Separate rpm and upstream versioning for epoch-free upgrade paths
- Include LICENSE
- "make test" no longer includes author tests

* Thu Nov  1 2007 Paul Howarth <paul@city-fan.org> 0.18-1
- Update to 0.18
- Clarify license as GPL version 1 or later, or Artistic (i.e. same as perl)

* Tue Jul 31 2007 Paul Howarth <paul@city-fan.org> 0.16-1
- Update to 0.16
- Fix dist tag for Fedora 7 onwards

* Mon Nov  6 2006 Paul Howarth <paul@city-fan.org> 0.14-1
- Update to 0.14
- Fix argument order for find with -depth
- Add buildreqs perl(Test::Pod) and perl(Test::Pod::Coverage) and make sure
  the coverage tests are run

* Fri Sep  1 2006 Paul Howarth <paul@city-fan.org> 0.13-2
- Fix distribution tags for development releases

* Fri Jun 23 2006 Paul Howarth <paul@city-fan.org> 0.13-1
- Update to 0.13

* Mon May 15 2006 Paul Howarth <paul@city-fan.org> 0.12-1
- Update to 0.12
- Add buildreq perl(Test::More) >= 0.4

* Fri Apr 21 2006 Paul Howarth <paul@city-fan.org> 0.10-1
- Update to 0.10
- Improve portability of rpm macros
- Use search.cpan.org URLs
- Remove buildroot unconditionally in %%clean and %%install
- Don't use macros in build-time command paths, hardcode them instead

* Fri Aug 26 2005 Paul Howarth <paul@city-fan.org> 0.09-3
- Import from Fedora Extras

* Fri Apr  7 2005 Michael Schwendt <mschwendt[AT]users.sf.net>
- rebuilt

* Thu Jul  8 2004 Jose Pedro Oliveira <jpo at di.uminho.pt> 0.09-1
- Update to 0.09 (with license info).

* Sun Jul  4 2004 Jose Pedro Oliveira <jpo at di.uminho.pt> 0:0.08-0.fdr.1
- First build.
